--v.1804_global_affairs

include( "PopupDialog" );

local UNHAPPINESS_LEVEL = -2;
local NUM_KILL = -1;
local MIN_POPULATION = 1 - NUM_KILL;
local cTable:table = {};
local extraAI:number = nil;
local gameTurn = 0;
local humanID;

local resHorses = GameInfo.Resources["RESOURCE_HORSES"].Index;
local resIron = GameInfo.Resources["RESOURCE_IRON"].Index;
local resUranium = GameInfo.Resources["RESOURCE_URANIUM"].Index; --TECH_COMPOSITES 
local resOil = GameInfo.Resources["RESOURCE_OIL"].Index; --TECH_COMBUSTION 

local techMilitaryScience = GameInfo.Technologies["TECH_MILITARY_SCIENCE"].Index; --UNIT_CAVALRY
local techHorseback = GameInfo.Technologies["TECH_HORSEBACK_RIDING"].Index; --UNIT_HORSEMAN
local techStirrups = GameInfo.Technologies["TECH_STIRRUPS"].Index; --UNIT_KNIGHT
local techIron = GameInfo.Technologies["TECH_IRON_WORKING"].Index; --UNIT_SWORDSMAN
local techComposites = GameInfo.Technologies["TECH_COMPOSITES"].Index; --UNIT_MODERN_ARMOR
local techCombustion = GameInfo.Technologies["TECH_COMBUSTION"].Index; --UNIT_TANK
local techSatellites = GameInfo.Technologies["TECH_SATELLITES"].Index; --UNIT_MECHANIZED_INFANTRY
local techAdvBallistics = GameInfo.Technologies["TECH_ADVANCED_BALLISTICS"].Index; --UNIT_MACHINE_GUN
local techReplaceableParts = GameInfo.Technologies["TECH_REPLACEABLE_PARTS"].Index; --UNIT_INFANTRY
local techBallistics = GameInfo.Technologies["TECH_BALLISTICS"].Index; --UNIT_FIELD_CANNON
local techMachinery = GameInfo.Technologies["TECH_MACHINERY"].Index; --UNIT_CROSSBOWMAN
local techArchery = GameInfo.Technologies["TECH_ARCHERY"].Index; --UNIT_ARCHER


local religionBonus = 0; --xxx
local humanReligion = -1;

local aiPlayers = 0; --xxx
local humanFriends = 0; --xxx
local hWarTurn = 0; --xxx


function OnCityAddedToMap(playerID, cityID)

	local cInstance = CityManager.GetCity(playerID, cityID);
	--print("OnCityAddedToMap: CITY ADDED:"..playerID.." "..cityID.." cInstance:"..tostring(cInstance));
	
	if (cInstance ~= nil) then
		table.insert(cTable, cInstance);
		local population = cInstance:GetPopulation();
		local plotX = cInstance:GetX();
		local plotY = cInstance:GetY();
		local cityname = cInstance:GetName();
		local cityowner = cInstance:GetOwner();
		local cityid = cInstance:GetID();
		cTable[cInstance] = { owner = cityowner, id = cityid, amen = -2, pop = population, x = plotX, y = plotY, name = cityname, siege = false };
	end
	
	if playerID == 62 then
		FreeCityExtra();
	end	
end

function CheckHappiness()

	local tAllPlayers = PlayerManager.GetAlive();
	local tempWarTurn = 0;
	for i, loopPlayer in ipairs(tAllPlayers) do
		local human:boolean = loopPlayer:IsHuman();
		if (not human) then
			local pPlayerCities:table = loopPlayer:GetCities();
			for i, cInstance in pPlayerCities:Members() do
				local cName:string = cInstance:GetName();
				local cPop = cInstance:GetPopulation();
				local happiness:number = cInstance:GetGrowth():GetHappiness();
				local initialH = cTable[cInstance].amen;
				local currentH2:number;
				local humanWar:boolean = loopPlayer:GetDiplomacy():IsAtWarWithHumans();
				if (happiness < 4) then
					cTable[cInstance].amen = initialH -1;
					currentH2 = cTable[cInstance].amen;
				else
					cTable[cInstance].amen = 0;
					currentH2 = cTable[cInstance].amen;
				end --if happiness
		
				if (currentH2 ~= nil and currentH2 < UNHAPPINESS_LEVEL and cPop >= MIN_POPULATION) then
					local cOwner:number = loopPlayer:GetID();
					if not humanWar then
						--print("UNHAPPINESS: BALANCING...cOwner:"..tostring(cOwner).." cPop:"..tostring(cPop).." "..tostring(cName).." "..tostring(gameTurn));
						cInstance:ChangePopulation(NUM_KILL);
						cTable[cInstance].amen = currentH2 +1;
					else -- if war
						if gameTurn - hWarTurn >= humanFriends then
							--print("UNHAPPINESS WAR: BALANCING...cOwner:"..tostring(cOwner).." cPop:"..tostring(cPop).." "..tostring(cName).." "..tostring(gameTurn));
							cInstance:ChangePopulation(NUM_KILL);
							cTable[cInstance].amen = currentH2 +1;
							tempWarTurn = gameTurn;
						end --gameTurn
					end
				end --if currentH
			end --cInstance
		end --not human
	end --loopPlayer
	if tempWarTurn > 0 then hWarTurn = tempWarTurn end;
end


function OnUnitKilledInCombat(pVictimID, unitKilled_ID, pKillerID, unitAttackerID)
------print("OnUnitKilledInCombat: "..tostring(pVictimID).." "..tostring(unitKilled_ID).." "..tostring(pKillerID).." "..tostring(unitAttackerID));

	if (pKillerID ~= -1) then
		if (not Players[pVictimID]:IsHuman() and not Players[pVictimID]:IsBarbarian()) then
			local pVictim = Players[pVictimID];
			local era1:number = pVictim:GetEra() +1;
			pVictim:GetTechs():ChangeCurrentResearchProgress(20*era1);
		else --is Human or is Barbarian
			if (not Players[pKillerID]:IsHuman() and not Players[pKillerID]:IsBarbarian()) then
				local era2:number = Players[pKillerID]:GetEra() +1;
				Players[pKillerID]:GetTechs():ChangeCurrentResearchProgress(10*era2);
			end --pKillerID
		end --a1
	end --pKillerID-1
end

function OnCitySiegeStatusChanged(a1, a2, a3)

	local pCity = CityManager.GetCity(a1, a2);
	local pPlayer = Players[a1];
	if pCity ~= nil then
		cTable[pCity].siege = a3;
		if (pPlayer:GetDiplomacy():IsAtWarWithHumans() and a3) then
			local cPop = pCity:GetPopulation();
			if (cPop >= MIN_POPULATION) then
				local unit = EraUnit(pPlayer);
				----print(unit);
				UnitManager.InitUnit(a1, unit, pCity:GetX(), pCity:GetY());
				pCity:ChangePopulation(NUM_KILL);
			end --cPop
		end --war with humans
	end	--pCity ~= nil
	--print("OnCitySiegeStatusChanged: "..tostring(a1).." "..tostring(a2).." "..tostring(a3).." "..tostring(pCity));
end

function ApplyExtra()

	if (extraAI == nil and gameTurn < 3) then
		local kPlayers	:table = PlayerManager.GetAliveMajors();
		for _, pOtherPlayer in ipairs(kPlayers) do
			local otherID:number = pOtherPlayer:GetID();
			local human = Players[otherID]:IsHuman();
			if not human then
				local maintenance = Players[otherID]:GetTreasury():GetUnitMaintenance();
				extraAI = maintenance - 2;
				LuaEvents.Custom_ExtraMaintenance(extraAI);
				--print("Passing: "..tostring(extraAI));
		break;
			end
		end
	end
	
	if extraAI ~= nil and extraAI > 0 then
		local kPlayers	:table = PlayerManager.GetAliveMajors();
		for _, pOtherPlayer in ipairs(kPlayers) do
			local otherID:number = pOtherPlayer:GetID();
			local human = Players[otherID]:IsHuman();
			if not human then
				Players[otherID]:GetTreasury():ChangeGoldBalance(extraAI);
			end
		end
	end --extraAI > 0
end

function FreeCityExtra()

	local fMaintenance = Players[62]:GetTreasury():GetUnitMaintenance();
	if fMaintenance > 0 then
		local freeExtra = math.ceil(fMaintenance);
		Players[62]:GetTreasury():ChangeGoldBalance(freeExtra);
		--print("HELPING FREE CITY: "..freeExtra);
	end
end

function OnDistrictDamageChanged( playerID:number, districtID:number, damageType:number, newDamage:number, oldDamage:number)

	if (damageType == DefenseTypes.DISTRICT_GARRISON) then --playerID == Game.GetLocalPlayer() and 
		for i, city in ipairs(cTable) do
			local cOwner:number = city:GetOwner();
			if cOwner == playerID then
				local cityID:number = city:GetID();
				local cityDistrict = city:GetDistricts():GetDistrict();
				if (cityDistrict ~= nil) then
					local cityDistrictID = cityDistrict:GetID();
					if cityDistrictID == districtID then
						local cityDistrictType = cityDistrict:GetType();
						if cityDistrictType == 0 then
							cTable[city].pop = city:GetPopulation();
							cTable[city].x = city:GetX();
							cTable[city].y = city:GetY();
							cTable[city].name = city:GetName();
							local maxHitpoints = cityDistrict:GetMaxDamage(DefenseTypes.DISTRICT_GARRISON);
							------print("CITY CENTER DAMAGED! "..playerID.." "..cityID.." "..maxHitpoints.." "..newDamage.." "..oldDamage);
							if (playerID == humanID and oldDamage == maxHitpoints - 1) then
								local cityName = Locale.Lookup(city:GetName());
								------print("CITY DESTROYED!: "..playerID.." "..cityID);
								CityManager.DestroyCity( playerID, cityID );
								local pPopupDialog	:table = PopupDialogInGame:new("BarbariansCityDestroyed"); 
								pPopupDialog:AddTitle( "City Destroyed!" );	
								pPopupDialog:AddText("Barbarians destroyed "..cityName.."!");
								pPopupDialog:AddDefaultButton("OK");
								pPopupDialog:Open();
							end --local player
						end --cityDistrictType
					break
					end --cityDistrictID
				end --cityDistrict not nil
			end --cOwner
		end --LOOP	
	end --damageType
end


function OnCityLoyaltyChanged(a1, a2, a3, a4, a5)
----print("OnCityLoyaltyChanged: "..tostring(a1).." "..tostring(a2).." "..tostring(a3).." "..tostring(a4).." "..tostring(a5));
end

function OnCityTransfered(a1, a2, a3, a4, a5)
----print("OnCityTransfered: "..tostring(a1).." "..tostring(a2).." "..tostring(a3).." "..tostring(a4).." "..tostring(a5));
end


function OnCulturalIdentityCityConverted(playerID, cityID, loserID, a4, a5)

	----print("OnCulturalIdentityCityConverted: "..tostring(playerID).." "..tostring(cityID).." "..tostring(loserID).." "..tostring(a4).." "..tostring(a5));

	if (loserID == humanID and playerID == 62) then
	
		local cInstance = CityManager.GetCity(playerID, cityID);
		local pPlayer = Players[loserID];
		local population = cInstance:GetPopulation();
		local uNumber = math.ceil(population *0.5 +1);
		--local popToKill = math.ceil(population/2*-1);
		
		--cInstance:ChangePopulation(popToKill);
		----print("CULTURE KILLING: "..tostring(popToKill));
		local unit = EraUnit(pPlayer);
		
			for i = 1, uNumber, 1 do 
			UnitManager.InitUnitValidAdjacentHex(playerID, unit, cInstance:GetX(), cInstance:GetY(), 1);
			--print("FREE CITY UNITS: "..tostring(era).." "..tostring(uNumber).." "..tostring(unit));
			end
	
	end --62
end


function OnCityRemovedFromMap(playerID, cityID)

	--print("OnCityRemovedFromMap: "..tostring(playerID).." "..tostring(cityID));

	for i, city in ipairs(cTable) do
		local cOwner:number = cTable[city].owner; --city:GetOwner();
		if cOwner == playerID then
			local backupID:number = cTable[city].id; --city:GetID();
			if (backupID == cityID) then
				local razedName:string = cTable[city].name;
				local razedPop = cTable[city].pop;
				local cPopAdd = math.floor(razedPop*0.5);
				--print(tostring(razedName).." "..tostring(razedPop).." "..tostring(cPopAdd));
				if cPopAdd > 0 then
					local cityX = cTable[city].x;
					local cityY = cTable[city].y;
					local pCity = FindClosestCity(playerID, cityX, cityY, razedName);
					if pCity ~= nil then
						local cName:string = pCity:GetName();
						local targetOwner = pCity:GetOwner();
						--print("Returned city: "..cName);
						pCity:ChangePopulation(cPopAdd);
						--print("REFUGEES from "..tostring(razedName).." with population "..tostring(razedPop).." went to "..tostring(cName).." adding "..tostring(cPopAdd));
						local visibility = Players[humanID]:GetDiplomacy():GetVisibilityOn(playerID);
						local atWar = Players[humanID]:GetDiplomacy():IsAtWarWith(playerID);
						if (visibility > 0 or atWar or targetOwner == humanID) then
							local pPopupDialog	:table = PopupDialogInGame:new("CityRazedScript"); 
							pPopupDialog:AddTitle(" Refugees Crisis!" );	
							pPopupDialog:AddText(tostring(cPopAdd).." refugees from "..tostring(Locale.Lookup(razedName)).." went to "..tostring(Locale.Lookup(cName))..".");
							pPopupDialog:AddDefaultButton("OK");
							pPopupDialog:Open();
						end
					end
				end --cPopAdd > 0
				table.remove( cTable, TableFindIndex(cTable, city));
				--print("City removed from table");
			break
			end
		end
	end
end

function FindClosestCity(player, iStartX, iStartY, razedName)

    local pCity = nullptr;
    local iShortestDistance = 12;
	local pPlayer = Players[player];
   
	local pPlayerCities:table = pPlayer:GetCities(); --or noPlayer GetCityAt ???
	for i, pLoopCity in pPlayerCities:Members() do
		local iDistance = Map.GetPlotDistance(iStartX, iStartY, pLoopCity:GetX(), pLoopCity:GetY());
		if (iDistance < iShortestDistance) then
			pCity = pLoopCity;
			iShortestDistance = iDistance;
		end
	end --first search owner

	if (pCity == nullptr) then
		--print ("No city found of city owner " .. tostring(pPlayer) .. " from " .. tostring(iStartX) .. ", " .. tostring(iStartY));
		local kPlayers	:table = PlayerManager.GetAliveIDs();
		for i, player2 in ipairs(kPlayers) do
			if not pPlayer:GetDiplomacy():IsAtWarWith(player2) then
				local pPlayer2Cities:table = Players[player2]:GetCities();
				for i, pLoopCity in pPlayer2Cities:Members() do
					local iDistance = Map.GetPlotDistance(iStartX, iStartY, pLoopCity:GetX(), pLoopCity:GetY());
					local pLoopName = pLoopCity:GetName();
					if (iDistance < iShortestDistance and pLoopName ~= razedName) then
						pCity = pLoopCity;
						iShortestDistance = iDistance;
					end
				end --loop2 cities
			end --IsAtWarWith
		end --loop1 players
	end	--second search not at war
		
	if (pCity == nullptr) then
		--print ("No city found of any player at peace ".. tostring(iStartX) .. ", " .. tostring(iStartY));
		--print ("RETURNING NIL");
		return nil;
	else  
		return pCity;
	end
end

function TableFindIndex(tab:table, id)

	for index, value in pairs(tab) do
		if value == id then
			return index;
		end
	end
end


function HappinessScore()

	local tMajors = PlayerManager.GetAliveMajors();

	for i, loopPlayer in ipairs(tMajors) do
		local loopPlayerScore = 0;
		local tCities = loopPlayer:GetCities();
		local loopPlayerCitiesNumber = 0;
		for i2, loopCity in tCities:Members() do
			local loopCityHappiness = loopCity:GetGrowth():GetHappiness();
			local loopCityPop = loopCity:GetPopulation();
			loopPlayerCitiesNumber = loopPlayerCitiesNumber + 1;
			loopPlayerScore = (loopPlayerScore + (loopCityHappiness * loopCityPop))/loopPlayerCitiesNumber;
		end
		--print("Player index: "..i.." Score: "..loopPlayerScore);	
	end
end

function WarWithHuman()

	--print(" ");

	local tMajors = PlayerManager.GetAliveMajors();
	local hWar = 0;
	local pWarTable = {};

	for i, aiPlayer in ipairs(tMajors) do
		if aiPlayer:GetDiplomacy():IsAtWarWithHumans() and not aiPlayer:IsBarbarian() then
			hWar = hWar + 1;
			local cLimit = aiPlayer:GetCities():GetCount();
			local aiPlayerID = aiPlayer:GetID();
			local era1:number = aiPlayer:GetEra() +1;
			local religionWar = math.ceil(cLimit*(era1^2)*0.5);
			local cultureWar = math.ceil(cLimit*(era1^2)*0.5);
			local goldWar = math.ceil(cLimit*(era1^2)*0.5);
			local scienceWar = math.ceil(cLimit*(era1^2)*0.5);
			table.insert(pWarTable, aiPlayerID);
			
			aiPlayer:GetReligion():ChangeFaithBalance(religionWar);
			aiPlayer:GetCulture():ChangeCurrentCulturalProgress(cultureWar);
			aiPlayer:GetTreasury():ChangeGoldBalance(goldWar);
			aiPlayer:GetTechs():ChangeCurrentResearchProgress(scienceWar);
			--print("WarWithHuman:"..tostring(aiPlayerID).." era1:"..tostring(era1).." cLimit:"..tostring(cLimit).." scienceWar:"..tostring(scienceWar).." cultureWar:"..tostring(cultureWar).." religionWar:"..tostring(religionWar).." goldWar:"..tostring(goldWar));
		end	--at war
	end --loop1
			
	if hWar > 0 then
		for i2, loopPlayer in ipairs(tMajors) do
			local loopPlayerDiplo = loopPlayer:GetDiplomacy(); 
			if not loopPlayerDiplo:IsAtWarWithHumans() and not loopPlayer:IsHuman() and not loopPlayer:IsBarbarian() then
				for i, pAtWar in ipairs(pWarTable) do
					if loopPlayerDiplo:HasMet(humanID) or loopPlayerDiplo:HasMet(pAtWar) then
					local cLimit2 = loopPlayer:GetCities():GetCount();
					local loopPlayerID = loopPlayer:GetID();
					local era2:number = loopPlayer:GetEra() +1;
					local religionWar2 = math.ceil(cLimit2*(era2^2)*0.25);
					local cultureWar2 = math.ceil(cLimit2*(era2^2)*0.25);
					local goldWar2 = math.ceil(cLimit2*(era2^2)*0.25);
					local scienceWar2 = math.ceil(cLimit2*(era2^2)*0.25);
			
					loopPlayer:GetReligion():ChangeFaithBalance(religionWar2);
					loopPlayer:GetCulture():ChangeCurrentCulturalProgress(cultureWar2);
					loopPlayer:GetTreasury():ChangeGoldBalance(goldWar2);
					loopPlayer:GetTechs():ChangeCurrentResearchProgress(scienceWar2);
					--print("WarTime:"..tostring(loopPlayerID).." era2:"..tostring(era2).." cLimit2:"..tostring(cLimit2).." science:"..tostring(scienceWar2).." culture:"..tostring(cultureWar2).." faith:"..tostring(religionWar2).." gold:"..tostring(goldWar2));
				break
					end
				end --loop pWarTable
			end --not human
		end --loop all other players
	end --war >0
end

function EraUnit(pPlayer:table) 

	local unit:string = nil;
	local isWarmonger = false;
	
	if not pPlayer:GetDiplomacy():IsAtWarWith(humanID) then
		local aliveIDs	:table = PlayerManager.GetAliveIDs();
		for i, alive in ipairs(aliveIDs) do
			if (alive <62 and pPlayer:GetDiplomacy():IsAtWarWith(alive)) then --alive ~= 62 otherwise => exploit!
				isWarmonger = true;
				--print("Player is at War with non-human: "..tostring(alive));
		break
			end --IsAtWarWith
		end --loop1 aliveIDs
	end
	
	if not isWarmonger then
	
		if pPlayer:GetResources():HasResource(resUranium) and pPlayer:GetTechs():HasTech(techComposites)  then
			unit = "UNIT_MODERN_ARMOR";
			return unit;
		end
	
		if pPlayer:GetResources():HasResource(resOil) and pPlayer:GetTechs():HasTech(techCombustion)  then
			unit = "UNIT_TANK";
			return unit;
		end
	
		if pPlayer:GetResources():HasResource(resHorses) then
			if pPlayer:GetTechs():HasTech(techMilitaryScience) then
				unit = "UNIT_CAVALRY";
				return unit;
			elseif pPlayer:GetTechs():HasTech(techHorseback) then
				unit = "UNIT_HORSEMAN";
				return unit;
			end
		end
	
		if pPlayer:GetResources():HasResource(resIron) then
			if pPlayer:GetTechs():HasTech(techStirrups) then
				unit = "UNIT_KNIGHT";
				return unit;
			elseif pPlayer:GetTechs():HasTech(techIron) then
				unit = "UNIT_SWORDSMAN";
				return unit;
			end
		end
	
		if pPlayer:GetTechs():HasTech(techSatellites) then
			unit = "UNIT_MECHANIZED_INFANTRY";
			return unit;
		elseif pPlayer:GetTechs():HasTech(techAdvBallistics) then
			unit = "UNIT_MACHINE_GUN";
			return unit;
		elseif pPlayer:GetTechs():HasTech(techReplaceableParts) then
			unit = "UNIT_INFANTRY";
			return unit;
		elseif pPlayer:GetTechs():HasTech(techBallistics) then
			unit = "UNIT_FIELD_CANNON";
			return unit;
		elseif pPlayer:GetTechs():HasTech(techMachinery) then
			unit = "UNIT_CROSSBOWMAN";
			return unit;
		elseif pPlayer:GetTechs():HasTech(techArchery) then
			unit = "UNIT_ARCHER";
			return unit;
		else
			unit = "UNIT_WARRIOR";
		end
	end --not isWarmonger
	return unit;
end

function CountMilitaryUnits(pID) --problem is script context does not allow for direct military strength valuation

	local unitCount = 0;
	local playerUnits = Players[pID]:GetUnits();
	for i, unit in playerUnits:Members() do
		local unitType = unit:GetType();
		if unitType > 19 then --this is risky sss, how to improve???
			unitCount = unitCount +1;	
		end
	end
	return unitCount;
end


function AdjustBonuses()

	local tMajors = PlayerManager.GetAliveMajors();
	local hMilitary = CountMilitaryUnits(humanID);
	--local hScience = Players[humanID]:GetTechs():GetScienceYield();
	--local hCulture = Players[humanID]:GetCulture():GetCultureYield();
	--local hReligion = Players[humanID]:GetReligion():GetFaithYield();
	local hFriends = 0; --temp during loop
	local adjustFriends = (1/aiPlayers)*humanFriends;
	local adjustFriendsGlobal = 1-adjustFriends;
	
	for i, aiPlayer in ipairs(tMajors) do
		if not aiPlayer:IsHuman() and not aiPlayer:IsBarbarian() then
			local aiPlayerID = aiPlayer:GetID();
			--print(" ");
			--print("PLAYER: "..aiPlayerID);
			local balance = aiPlayer:GetTreasury():GetGoldBalance();
			local era = aiPlayer:GetEra() +1;
			local goldRequirement = era*(extraAI+2)
			local finalBalance = balance - goldRequirement;
			local aiPlayerDiplomaticAI = aiPlayer:GetAi_Diplomacy();
			local relationshipState = aiPlayerDiplomaticAI:GetDiplomaticState(humanID);
			local fFactor = 1;
			local visibilityState = aiPlayer:GetDiplomacy():GetVisibilityOn(humanID);
			local pMilitary = CountMilitaryUnits(aiPlayerID);
			local pScience = aiPlayer:GetTechs():GetScienceYield();
			local pCulture = aiPlayer:GetCulture():GetCultureYield();
			local pReligion = aiPlayer:GetReligion():GetFaithYield();
			local mRatio = (hMilitary/pMilitary);
			--local sDelta = (hScience - pScience);
			--local cDelta = (hCulture - pCulture);
			--local rDelta = (hReligion - pReligion);
			local unit = nil;
			if (relationshipState ~= nil and aiPlayer:GetDiplomacy():HasMet(humanID)) then
				----print(relationshipState.." "..Round(finalBalance, 2).." "..Round(mRatio, 2).." "..Round(sDelta, 2).." "..Round(cDelta, 2).." "..Round(rDelta, 2));
				--print(relationshipState.." "..Round(finalBalance, 2).." "..Round(mRatio, 2));
				if (relationshipState == "DIPLO_STATE_ALLIED") then
					hFriends = hFriends +1;
					fFactor = 0;
					if (finalBalance > 0) then
						if mRatio > 2.5 + adjustFriends then 
							unit = EraUnit(aiPlayer);
						end
					end --balance
				end
					
				if (relationshipState == "DIPLO_STATE_DECLARED_FRIEND") then
					hFriends = hFriends +1;
					fFactor = 0;
					if (finalBalance > 0) then
						if mRatio > 2 + adjustFriends then 
							unit = EraUnit(aiPlayer);
						end
						--if sDelta > 0 then
							--sBonus = math.ceil(sDelta*0.2);
							--aiPlayer:GetTechs():ChangeCurrentResearchProgress(sBonus);
							----print("Science bonus: "..sBonus);
						--end
						--if rDelta > 0 then
							--rBonus = math.ceil(rDelta*0.2);
							--aiPlayer:GetReligion():ChangeFaithBalance(rBonus);
							----print("Religion bonus: "..rBonus);
						--end
					end --balance
				end --relationshipState
				if (relationshipState == "DIPLO_STATE_FRIENDLY") then
					hFriends = hFriends +1;
					fFactor = 0;
					if (finalBalance > 0) then
						if mRatio > 1.6 + adjustFriends then 
							unit = EraUnit(aiPlayer);
						end
					end --balance
				end
				-----------------------------------------------------------------------------------
				if (relationshipState == "DIPLO_STATE_NEUTRAL") then
					fFactor = 0.5;
					if (finalBalance > 0) then
						if mRatio > 1.3 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				if (relationshipState == "DIPLO_STATE_UNFRIENDLY") then
					if (finalBalance > 0) then
						if mRatio > 1 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				if (relationshipState == "DIPLO_STATE_DENOUNCED") then
					if (finalBalance > 0) then
						if mRatio > 0.8 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				if (relationshipState == "DIPLO_STATE_WAR") then
					if (finalBalance > 0) then
						if mRatio > 0.6 + adjustFriends then
							unit = EraUnit(aiPlayer);
						end
					end	
				end
				
				--COMBAT UNITS:
				if unit ~= nil  then
					local pPlayerCities:table = aiPlayer:GetCities();
					for i, pLoopCity in pPlayerCities:Members() do
						local underSiege = cTable[pLoopCity].siege;
						--print("SIEGE: "..tostring(underSiege));
						if not underSiege then
							local cX = pLoopCity:GetX();
							local cY = pLoopCity:GetY();
							UnitManager.InitUnit(aiPlayerID, unit, cX, cY);
							--print("GRANTING BONUS UNIT: "..aiPlayerID.." "..unit.." "..pLoopCity:GetName());
					break
						end --siege
					end --pLoopCity 
				end --unit
			end --relationshipState not nil
			
			--GLOBALIZATION:
			for i2, aiPlayer2 in ipairs(tMajors) do
				local aiPlayer2ID = aiPlayer2:GetID();
				local relationshipState2 = aiPlayerDiplomaticAI:GetDiplomaticState(aiPlayer2ID);
				if (not aiPlayer2:IsHuman() and aiPlayer2ID ~= aiPlayerID and relationshipState2 ~= nil and aiPlayer:GetDiplomacy():HasMet(aiPlayer2ID)) then
					if relationshipState2 == "DIPLO_STATE_ALLIED" or relationshipState2 == "DIPLO_STATE_DECLARED_FRIEND" or relationshipState2 == "DIPLO_STATE_FRIENDLY" then
						local pCultureGlobal = math.ceil(pCulture*adjustFriendsGlobal*0.5 *fFactor);
						local pScienceGlobal = math.ceil(pScience*adjustFriendsGlobal*0.5 *fFactor);
						local pReligionGlobal = math.ceil(pReligion*adjustFriendsGlobal*0.5 *fFactor);
						aiPlayer2:GetCulture():ChangeCurrentCulturalProgress(pCultureGlobal);
						aiPlayer2:GetTechs():ChangeCurrentResearchProgress(pScienceGlobal);
						aiPlayer2:GetReligion():ChangeFaithBalance(pReligionGlobal);
						--print(" ");
						--print(tostring(aiPlayerID).." -> "..aiPlayer2ID.." "..relationshipState2);
						--print("Science shared: "..pScience.." "..adjustFriendsGlobal.." "..pScienceGlobal);
						--print("Culture shared: "..pCulture.." "..adjustFriendsGlobal.." "..pCultureGlobal);
						--print("Faith shared: "..pReligion.." "..adjustFriendsGlobal.." "..pReligionGlobal);
					elseif relationshipState2 == "DIPLO_STATE_NEUTRAL" then
						local pCultureGlobal = math.ceil(pCulture*adjustFriendsGlobal*0.25 *fFactor);
						local pScienceGlobal = math.ceil(pScience*adjustFriendsGlobal*0.25 *fFactor);
						local pReligionGlobal = math.ceil(pReligion*adjustFriendsGlobal*0.25 *fFactor);
						aiPlayer2:GetCulture():ChangeCurrentCulturalProgress(pCultureGlobal);
						aiPlayer2:GetTechs():ChangeCurrentResearchProgress(pScienceGlobal);
						aiPlayer2:GetReligion():ChangeFaithBalance(pReligionGlobal);
						--print(" ");
						--print(tostring(aiPlayerID).." -> "..aiPlayer2ID.." "..relationshipState2);
						--print("Science shared: "..pScience.." "..adjustFriendsGlobal.." "..pScienceGlobal);
						--print("Culture shared: "..pCulture.." "..adjustFriendsGlobal.." "..pCultureGlobal);
						--print("Faith shared: "..pReligion.." "..adjustFriendsGlobal.." "..pReligionGlobal);
					else
						--print(" ");
						--print(tostring(aiPlayerID).." -> "..aiPlayer2ID.." "..relationshipState2);
					end --relationshipState2
				end --not aiPlayer2:IsHuman()
			end --aiPlayer2
		end
	end --loop1
	
	humanFriends = hFriends;
	
end

function Round(num, numDecimalPlaces)
    local mult = 10^(numDecimalPlaces or 0)
    if num >= 0 then return math.floor(num * mult + 0.5) / mult
    else return math.ceil(num * mult - 0.5) / mult end
end


function OnTurnBegin(turn)
	--print("-------------------------");
	gameTurn = turn;
	--print("TURN BEGIN: "..gameTurn);
	--CheckHappiness();
	--print("-------------------------");
end

function OnTurnEnd(turn)
	gameTurn = turn;
	--print("--------------------------------------------------");
	--print("TURN END: "..gameTurn);
	ApplyExtra();
	AdjustBonuses();
	WarWithHuman();
	ApplyReligionBonus();
	
	--print(" ");
	LuaEvents.Custom_ExtraHappiness(hWarTurn);
	LuaEvents.Custom_Friends(humanFriends);
	--print("gameTurn:"..tostring(gameTurn).." hWarTurn:"..tostring(hWarTurn).." "..tostring(gameTurn-hWarTurn));
	--print("--------------------------------------------------");
end

function OnLocalPlayerTurnBegin()
	--print("---------");
	--print("OnLocalPlayerTurnBegin");
	CheckHappiness();
	if Players[62]:IsAlive() then
		FreeCityExtra();
	end
	--LuaEvents.Custom_ExtraReligion(religionBonus);
	--print("---------");
end

function OnUnitChargesChanged(player, unitId) --xxx

	if(gameTurn ~= 0 and player == humanID) then
		local unit = UnitManager.GetUnit(player, unitId);
		if (unit:GetReligion():GetReligiousStrength()) > 0 then
			religionBonus = religionBonus +1;
			LuaEvents.Custom_ExtraReligion(religionBonus);
		end
	end
end

function ApplyReligionBonus() --xxx

	if (religionBonus >= 3) then
		religionBonus = religionBonus -3;
		local tAllPlayers = PlayerManager.GetAlive();
		for i, loopPlayer in ipairs(tAllPlayers) do
			local loopPlayerID = loopPlayer:GetID();
			if loopPlayerID ~= humanID then 
				local faithBalance = loopPlayer:GetReligion():GetFaithBalance()
				local creator = loopPlayer:GetReligion():GetReligionTypeCreated();
				local unitOwner;
				local minFaith = 200;
					--if creator > -1 then minFaith = 200; else minFaith = 400; end
				if (faithBalance >= minFaith) then
					local tCities = loopPlayer:GetCities();
					for i2, pLoopCity in tCities:Members() do
						local religionType = pLoopCity:GetReligion():GetMajorityReligion();
						if (religionType == creator or (religionType == humanReligion and creator == -1)) then
							if religionType == creator then unitOwner = loopPlayerID; else unitOwner = humanID; end
							local hasShrine = pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_SHRINE"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_SHRINE"].Index); --xxx
							local hasTemple = (pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_TEMPLE"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_TEMPLE"].Index)) or (pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_STAVE_CHURCH"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_STAVE_CHURCH"].Index)) or (pLoopCity:GetBuildings():HasBuilding(GameInfo.Buildings["BUILDING_PRASAT"].Index) and not pLoopCity:GetBuildings():IsPillaged(GameInfo.Buildings["BUILDING_PRASAT"].Index)); --xxx
							local hasInquisition = loopPlayer:GetReligion():HasLaunchedInquisition();
							local pLoopName = pLoopCity:GetName();
							local cX = pLoopCity:GetX();
							local cY = pLoopCity:GetY();
							if hasTemple and faithBalance >= minFaith then
								UnitManager.InitUnitValidAdjacentHex(unitOwner, "UNIT_APOSTLE", cX, cY, 1);
								faithBalance = faithBalance - minFaith;
								if religionType == humanReligion then religionBonus = religionBonus -4; --print("religionBonus: "..-4); 
								end
								--print("GRANTED RELIGIOUS UNIT: "..pLoopName.." UNIT_APOSTLE "..faithBalance);
							end
							if hasShrine and faithBalance >= minFaith *0.25 then
								UnitManager.InitUnitValidAdjacentHex(unitOwner, "UNIT_MISSIONARY", cX, cY, 1);
								faithBalance = faithBalance - minFaith *0.25;
								if religionType == humanReligion then religionBonus = religionBonus -4; --print("religionBonus: "..-4); 
								end
								--print("GRANTED RELIGIOUS UNIT: "..pLoopName.." UNIT_MISSIONARY "..faithBalance);
							end
							if religionType == creator and hasTemple and hasInquisition and faithBalance >= minFaith *0.25 then
								UnitManager.InitUnitValidAdjacentHex(unitOwner, "UNIT_INQUISITOR", cX, cY, 1);
								faithBalance = faithBalance - minFaith *0.25;
								--print("GRANTED RELIGIOUS UNIT: "..pLoopName.." UNIT_INQUISITOR "..faithBalance);
							end
						end --religionType
					end --pLoopCity
				end --faithBalance
			end --loopPlayerID ~= humanID 
		end --loopPlayer
		
		SetUnitsReligion();
		
	end	--religionBonus
end



function SetUnitsReligion()

	local tAllPlayers = PlayerManager.GetAlive();
	for i, loopPlayer in ipairs(tAllPlayers) do
		local loopPlayerID = loopPlayer:GetID();
		local creator = loopPlayer:GetReligion():GetReligionTypeCreated();
		local tUnits = loopPlayer:GetUnits();
		for i, unit in tUnits:Members() do
			if (unit:GetReligion():GetReligiousStrength() > 0 and  unit:GetReligion():GetReligionType() == -1) then
					local unitID = unit:GetID();
					local unitX = unit:GetX();
					local unitY = unit:GetY();
					unit:GetReligion():SetReligionType(creator);
					----print("SetUnitsReligion");
			end --GetReligiousStrength
		end --loop unit
	end --loopPlayer
end

function OnUnitArtifactChanged(a1, a2, a3, a4)
	--print("OnUnitArtifactChanged: "..tostring(a1).." "..tostring(a2).." "..tostring(a3).." "..tostring(a4));
	--UnhappinessScript: OnUnitArtifactChanged: 0 18808907 nil nil
end

function Initialize()
	--print("--------------------------------------------------");
	
	Events.CityAddedToMap.Add( OnCityAddedToMap );
	Events.TurnBegin.Add( OnTurnBegin );
	Events.TurnEnd.Add( OnTurnEnd );
	Events.LocalPlayerTurnBegin.Add( OnLocalPlayerTurnBegin );

	Events.UnitKilledInCombat.Add( OnUnitKilledInCombat );
	Events.CitySiegeStatusChanged.Add( OnCitySiegeStatusChanged );
	Events.DistrictDamageChanged.Add( OnDistrictDamageChanged );
	
	--Events.CulturalIdentityCityConverted.Add( OnCulturalIdentityCityConverted );
	Events.UnitChargesChanged.Add( OnUnitChargesChanged );
	--Events.UnitArtifactChanged.Add( OnUnitArtifactChanged );
	
	Events.CityRemovedFromMap.Add( OnCityRemovedFromMap );
	
	extraAI = GameConfiguration.GetValue("extraMaintenance");
	if GameConfiguration.GetValue("humanFriends") ~= nil then humanFriends = GameConfiguration.GetValue("humanFriends") end;
	if GameConfiguration.GetValue("religionBonus") ~= nil then religionBonus = GameConfiguration.GetValue("religionBonus") end;
	if GameConfiguration.GetValue("hWarTurn") ~= nil then hWarTurn = GameConfiguration.GetValue("hWarTurn") end;
	
	aiPlayers = PlayerManager.GetWasEverAliveMajorsCount() -1;
	humanID = Game.GetLocalPlayer();
	humanReligion = Players[humanID]:GetReligion():GetReligionTypeCreated();
	
	print("UNHAPPINESS STARTED: v.1804_global_affairs");
	--print("ExtraAI: "..tostring(extraAI));
	--print("humanFriends: "..tostring(humanFriends));
	--print("religionBonus: "..tostring(religionBonus));
	--print("hWarTurn: "..tostring(hWarTurn));
	--print("aiPlayers: "..tostring(aiPlayers));
	--print("--------------------------------------------------");
	
end

Initialize();
