--v.1804_global_affairs

--Districts required population
UPDATE GlobalParameters SET Value=2 WHERE Name="DISTRICT_POPULATION_REQUIRED_PER";

--DIPLOMACY:
UPDATE ModifierArguments SET Value=Value*2 WHERE ModifierId="STANDARD_DIPLOMATIC_CONVERTED_CITY" AND Name="InitialValue";
--INSERT INTO ModifierArguments (ModifierId, Name, Type, Value) VALUES ("STANDARD_DIPLOMATIC_CONVERTED_CITY", "ModifierPerTransgression", "ARGTYPE_IDENTITY", -8);
--INSERT INTO ModifierArguments (ModifierId, Name, Type, Value) VALUES ("STANDARD_DIPLOMATIC_CONVERTED_CITY", "MaxValue", "ARGTYPE_IDENTITY", -28);

UPDATE ModifierArguments SET Value=9 WHERE ModifierId="STANDARD_DIPLOMATIC_ALLY" AND Name="InitialValue";
UPDATE ModifierArguments SET Value=6 WHERE ModifierId="STANDARD_DIPLOMATIC_DECLARED_FRIEND" AND Name="InitialValue";
UPDATE ModifierArguments SET Value=6 WHERE ModifierId="STANDARD_DIPLOMATIC_DEFENSIVE_PACT" AND Name="InitialValue";


--YIELD CHANGES:
--FOOD: Tiles produce 1 food less.
UPDATE Terrain_YieldChanges SET YieldChange=YieldChange-1 WHERE rowid <7;
UPDATE Improvement_YieldChanges SET YieldChange=YieldChange+1 WHERE YieldType="YIELD_FOOD" OR YieldType="YIELD_PRODUCTION" OR YieldType="YIELD_GOLD" AND NOT YieldChange=0;
--For balance also increase buildings yield changes where food or production or gold
UPDATE Building_YieldChanges SET YieldChange=YieldChange+1 WHERE YieldType="YIELD_FOOD" OR YieldType="YIELD_PRODUCTION" OR YieldType="YIELD_GOLD" AND NOT BuildingType="BUILDING_PALACE";
UPDATE Building_YieldChanges SET YieldChange=YieldChange+2 WHERE YieldType="YIELD_SCIENCE" OR YieldType="YIELD_CULTURE" AND NOT BuildingType="BUILDING_PALACE" AND NOT BuildingType="BUILDING_MONUMENT";
--Districts citizen yields doubled;
UPDATE District_CitizenYieldChanges SET YieldChange = YieldChange*2;

--Nerfed Palace yields.
UPDATE Building_YieldChanges SET YieldChange=3 WHERE BuildingType="BUILDING_PALACE" AND YieldType="YIELD_GOLD";
UPDATE Building_YieldChanges SET YieldChange=1 WHERE BuildingType="BUILDING_PALACE" AND YieldType="YIELD_SCIENCE";
UPDATE Building_YieldChanges SET YieldChange=1 WHERE BuildingType="BUILDING_PALACE" AND YieldType="YIELD_CULTURE";
INSERT INTO Building_YieldChanges (BuildingType, YieldType, YieldChange) VALUES ("BUILDING_PALACE", "YIELD_FAITH", 0);
DELETE FROM Building_YieldChanges WHERE BuildingType="BUILDING_PALACE" AND YieldType="YIELD_PRODUCTION";

--Population does not produce Science and produce only minimum Culture.
UPDATE GlobalParameters SET Value=0 WHERE Name="CULTURE_PERCENTAGE_YIELD_PER_POP";
UPDATE GlobalParameters SET Value=0 WHERE Name="SCIENCE_PERCENTAGE_YIELD_PER_POP";

--BUILDINGS MAINTENANCE: Doubled for all buildings.
UPDATE Buildings SET Maintenance = Maintenance*2;
--Granary +2, WaterMill +1.
UPDATE Buildings SET Maintenance=2 WHERE BuildingType="BUILDING_GRANARY";
UPDATE Buildings SET Maintenance=1 WHERE BuildingType="BUILDING_WATER_MILL";

--SCIENCE:
--UPDATE Yields SET DefaultValue=1 WHERE YieldType="YIELD_SCIENCE";
UPDATE Adjacency_YieldChanges SET TilesRequired=1 WHERE ID="District_Science"; --v3 --Campus district adjacency buffed to standard (+1).

--ENCAMPMENT:
--Encampment produces Science instead of Culture;
DELETE FROM District_CitizenYieldChanges WHERE DistrictType="DISTRICT_ENCAMPMENT" AND YieldType="YIELD_CULTURE";
INSERT INTO District_CitizenYieldChanges (DistrictType, YieldType, YieldChange) VALUES ("DISTRICT_ENCAMPMENT", "YIELD_SCIENCE", 2);
UPDATE Project_YieldConversions SET YieldType="YIELD_SCIENCE" WHERE ProjectType="PROJECT_ENHANCE_DISTRICT_ENCAMPMENT";


--UNIT MAINTENANCE:
--For Scout and Slinger +1. +2 for all other units.
--Gold income becomes critical.
--Stops warrior spamming by AI.
UPDATE Units SET Maintenance=Maintenance+2 WHERE rowid >18 
AND NOT UnitType="UNIT_BARBARIAN_HORSEMAN" 
AND NOT UnitType="UNIT_BARBARIAN_HORSE_ARCHER" 
AND NOT UnitType="UNIT_BARBARIAN_RAIDER"
AND NOT UnitType="UNIT_SCOUT"
AND NOT UnitType="UNIT_SLINGER" 
AND NOT UnitType="UNIT_CREE_OKIHTCITAW";

UPDATE Units SET Maintenance=Maintenance+1 WHERE UnitType="UNIT_SCOUT" OR UnitType="UNIT_SLINGER" OR UnitType="UNIT_CREE_OKIHTCITAW";
--UPDATE Units SET Cost=Cost*0.5;

--Units disbanded immediately at negative Gold balance.
UPDATE GlobalParameters SET Value=-1 WHERE Name="GOLD_NEGATIVE_BALANCE_DISBAND_UNIT_LINE";
UPDATE GlobalParameters SET Value=-3 WHERE Name="GOLD_NEGATIVE_BALANCE_SUBSEQUENT_DISBAND_UNIT";


--HAPPINESS:
--Luxury resources distributed "old style": 1 luxury for 1 population, no limit on number of cities.
UPDATE GlobalParameters SET Value=1 WHERE Name="CITY_POP_PER_AMENITY";
UPDATE GlobalParameters SET Value=2 WHERE Name="CITY_AMENITIES_FOR_FREE";
UPDATE Resources SET Happiness = 99 WHERE ResourceClassType="RESOURCECLASS_LUXURY" AND NOT Frequency = 0; --NOT Unique Luxury

--Unhappiness has more severe effect for city order and loyalty.
UPDATE Happinesses SET MinimumAmenityScore=-1 WHERE HappinessType="HAPPINESS_DISPLEASED";
UPDATE Happinesses SET MinimumAmenityScore=-2, MaximumAmenityScore=-2 WHERE HappinessType="HAPPINESS_UNHAPPY";
UPDATE Happinesses SET MinimumAmenityScore=-3, MaximumAmenityScore=-3 WHERE HappinessType="HAPPINESS_UNREST";
UPDATE Happinesses SET MaximumAmenityScore=-4 WHERE HappinessType="HAPPINESS_REVOLT";

UPDATE Happinesses SET RebellionPoints=RebellionPoints+5 WHERE rowid <5; --Cities will not stop growing v3 +increased rebellion points.
UPDATE GlobalParameters SET Value=5 WHERE Name="REBELLION_COOLDOWN_TURNS";
--Unhappiness has more severe effect on city loyalty (RF only);
UPDATE Happinesses_XP1 SET IdentityPerTurnChange=IdentityPerTurnChange*2-3 WHERE HappinessType="HAPPINESS_DISPLEASED";
UPDATE Happinesses_XP1 SET IdentityPerTurnChange=IdentityPerTurnChange*2-4 WHERE HappinessType="HAPPINESS_UNHAPPY";
UPDATE Happinesses_XP1 SET IdentityPerTurnChange=IdentityPerTurnChange*4 WHERE HappinessType="HAPPINESS_UNREST";
UPDATE Happinesses_XP1 SET IdentityPerTurnChange=IdentityPerTurnChange*5 WHERE HappinessType="HAPPINESS_REVOLT";
--Governor +Ecstatic =20
UPDATE Happinesses_XP1 SET IdentityPerTurnChange=IdentityPerTurnChange*2 WHERE HappinessType="HAPPINESS_HAPPY";
UPDATE Happinesses_XP1 SET IdentityPerTurnChange=IdentityPerTurnChange*2 WHERE HappinessType="HAPPINESS_ECSTATIC";


--DISTRICTS Encampment, Campus and HolySite are available from the beginning.
UPDATE Districts SET PrereqTech= null WHERE DistrictType="DISTRICT_CAMPUS";
UPDATE Districts SET PrereqTech= null WHERE DistrictType="DISTRICT_HOLY_SITE";
UPDATE Districts SET PrereqTech= null WHERE DistrictType="DISTRICT_ENCAMPMENT";
--Replacements:
UPDATE Districts SET PrereqTech= null WHERE DistrictType="DISTRICT_SEOWON";
UPDATE Districts SET PrereqTech= null WHERE DistrictType="DISTRICT_LAVRA";
UPDATE Districts SET PrereqTech= null WHERE DistrictType="DISTRICT_IKANDA";


-------AI--------
-----------------

--COMMERCIAL:
INSERT INTO AiListTypes (ListType) VALUES ("CommDistrictForcer");
INSERT INTO AiLists (ListType, LeaderType, System) VALUES ("CommDistrictForcer", "TRAIT_LEADER_MAJOR_CIV", "Districts");
INSERT INTO AiFavoredItems (ListType, Item, Favored) VALUES ("CommDistrictForcer", "DISTRICT_COMMERCIAL_HUB", 1);
UPDATE AiFavoredItems SET Favored=1 WHERE ListType="MinorCivDistricts" AND Item="DISTRICT_COMMERCIAL_HUB";

UPDATE Yields SET DefaultValue=1 WHERE YieldType="YIELD_GOLD";

--CULTURE: xxx
INSERT INTO AiListTypes (ListType) VALUES ("CultDistrictForcer");
INSERT INTO AiLists (ListType, LeaderType, System) VALUES ("CultDistrictForcer", "TRAIT_LEADER_MAJOR_CIV", "Districts");
INSERT INTO AiFavoredItems (ListType, Item, Favored) VALUES ("CultDistrictForcer", "DISTRICT_THEATHER", 1);
UPDATE PseudoYields SET DefaultValue=3 WHERE PseudoYieldType="PSEUDOYIELD_TOURISM";




--AI happiness.
UPDATE AiFavoredItems SET Favored=1, Value=5 WHERE ListType="StandardSettlePlot" AND StringVal="RESOURCECLASS_LUXURY";
UPDATE PseudoYields SET DefaultValue=3 WHERE PseudoYieldType="PSEUDOYIELD_HAPPINESS";

--AI builds less wonders. xxx
--UPDATE PseudoYields SET DefaultValue=0.1 WHERE PseudoYieldType="PSEUDOYIELD_WONDER";

--STRATEGIES:
--Fixed apparent copy/paste Firaxis bug for Medieval strategy.
UPDATE StrategyConditions SET ConditionFunction="Is Medieval" WHERE StrategyType="STRATEGY_MEDIEVAL_CHANGES" AND Disqualifier=0; --AI DELETED
INSERT INTO Strategy_Priorities (StrategyType, ListType) VALUES ("STRATEGY_MEDIEVAL_CHANGES", "MedievalSettlements"); --xxx

--AI more aware if it is on island or not.
UPDATE GlobalParameters SET Value=40 WHERE Name="AI_ISLAND_COAST_PERCENTAGE";

--Fixed apparent Firaxis typos in AiFavoredItems:
DELETE FROM AiFavoredItems WHERE Item="YEILD_CULTURE";
INSERT INTO AiFavoredItems (ListType, Item, Favored, Value) VALUES ("DefaultYieldBias", "YIELD_CULTURE", 1, 10);
DELETE FROM AiFavoredItems WHERE Item="YEILD_FAITH";
INSERT INTO AiFavoredItems (ListType, Item, Favored, Value) VALUES ("DefaultYieldBias", "YIELD_FAITH", 1, -25);
DELETE FROM AiFavoredItems WHERE Item="YEILD_GOLD";
INSERT INTO AiFavoredItems (ListType, Item, Favored, Value) VALUES ("DefaultYieldBias", "YIELD_GOLD", 1, 20);
DELETE FROM AiFavoredItems WHERE Item="YEILD_PRODUCTION";
INSERT INTO AiFavoredItems (ListType, Item, Favored, Value) VALUES ("DefaultYieldBias", "YIELD_PRODUCTION", 1, 25);
DELETE FROM AiFavoredItems WHERE Item="YEILD_SCIENCE";
INSERT INTO AiFavoredItems (ListType, Item, Favored, Value) VALUES ("DefaultYieldBias", "YIELD_SCIENCE", 1, 10);


--AI now more reluctant to go for Religious and Cultural victories;
--UPDATE Strategies SET NumConditionsNeeded=3 WHERE StrategyType="VICTORY_STRATEGY_RELIGIOUS_VICTORY" OR StrategyType="VICTORY_STRATEGY_CULTURAL_VICTORY"; --AI NONE

--INSERT INTO Strategy_Priorities (StrategyType, ListType) VALUES ("VICTORY_STRATEGY_RELIGIOUS_VICTORY", "NavalPreferredTechs");

--AI stops expansion and exploration strategies when at war;
--UPDATE Strategies SET NumConditionsNeeded=2 WHERE StrategyType="STRATEGY_EARLY_EXPLORATION"; --AI SAME
--INSERT INTO StrategyConditions (StrategyType, ConditionFunction, StringValue, ThresholdValue, Forbidden, Disqualifier, Exclusive)
--VALUES           ("STRATEGY_EARLY_EXPLORATION", "Major Civ Wars", null,         0,               0, 0, 0); --AI OK

--UPDATE StrategyConditions SET ThresholdValue=0 WHERE StrategyType="STRATEGY_RAPID_EXPANSION" AND ConditionFunction="Major Civ Wars"; --AI DELETED
--DELETE FROM AiFavoredItems WHERE ListType="ExpansionUnitPreferences" AND Item="PSEUDOYIELD_UNIT_COMBAT"; --AI OK

